<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="设备ID" prop="deviceId">
        <el-input
          v-model="queryParams.deviceId"
          placeholder="设备ID"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="使用次数" prop="usageCount">
        <el-input
          v-model="queryParams.usageCount"
          placeholder="请输入使用次数"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="总使用时长(秒)" prop="totalDuration">
        <el-input
          v-model="queryParams.totalDuration"
          placeholder="请输入总使用时长(秒)"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="今日使用时长" prop="dailyDuration">
        <el-input
          v-model="queryParams.dailyDuration"
          placeholder="请输入今日使用时长"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="本周使用时长" prop="weeklyDuration">
        <el-input
          v-model="queryParams.weeklyDuration"
          placeholder="请输入本周使用时长"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="本月使用时长" prop="monthlyDuration">
        <el-input
          v-model="queryParams.monthlyDuration"
          placeholder="请输入本月使用时长"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="最后使用时间" prop="lastUsedTime">
        <el-date-picker clearable
          v-model="queryParams.lastUsedTime"
          type="date"
          value-format="YYYY-MM-DD"
          placeholder="请选择最后使用时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['device:usage:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['device:usage:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['device:usage:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['device:usage:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="usageList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="设备ID" align="center" prop="deviceId" />
      <el-table-column label="按头类型" align="center" prop="headType" />
      <el-table-column label="使用次数" align="center" prop="usageCount" />
      <el-table-column label="总使用时长(秒)" align="center" prop="totalDuration" />
      <el-table-column label="今日使用时长" align="center" prop="dailyDuration" />
      <el-table-column label="本周使用时长" align="center" prop="weeklyDuration" />
      <el-table-column label="本月使用时长" align="center" prop="monthlyDuration" />
      <el-table-column label="最后使用时间" align="center" prop="lastUsedTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.lastUsedTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['device:usage:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['device:usage:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改设备按头使用统计对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="usageRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="${comment}" prop="deviceId">
          <el-input v-model="form.deviceId" placeholder="请输入${comment}" />
        </el-form-item>
        <el-form-item label="使用次数" prop="usageCount">
          <el-input v-model="form.usageCount" placeholder="请输入使用次数" />
        </el-form-item>
        <el-form-item label="总使用时长(秒)" prop="totalDuration">
          <el-input v-model="form.totalDuration" placeholder="请输入总使用时长(秒)" />
        </el-form-item>
        <el-form-item label="今日使用时长" prop="dailyDuration">
          <el-input v-model="form.dailyDuration" placeholder="请输入今日使用时长" />
        </el-form-item>
        <el-form-item label="本周使用时长" prop="weeklyDuration">
          <el-input v-model="form.weeklyDuration" placeholder="请输入本周使用时长" />
        </el-form-item>
        <el-form-item label="本月使用时长" prop="monthlyDuration">
          <el-input v-model="form.monthlyDuration" placeholder="请输入本月使用时长" />
        </el-form-item>
        <el-form-item label="最后使用时间" prop="lastUsedTime">
          <el-date-picker clearable
            v-model="form.lastUsedTime"
            type="date"
            value-format="YYYY-MM-DD"
            placeholder="请选择最后使用时间">
          </el-date-picker>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Usage">
import { listUsage, getUsage, delUsage, addUsage, updateUsage } from "@/api/usage/usage"

const { proxy } = getCurrentInstance()

const usageList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    deviceId: null,
    headType: null,
    usageCount: null,
    totalDuration: null,
    dailyDuration: null,
    weeklyDuration: null,
    monthlyDuration: null,
    lastUsedTime: null,
  },
  rules: {
    deviceId: [
      { required: true, message: "$comment不能为空", trigger: "blur" }
    ],
    headType: [
      { required: true, message: "按头类型不能为空", trigger: "change" }
    ],
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询设备按头使用统计列表 */
function getList() {
  loading.value = true
  listUsage(queryParams.value).then(response => {
    usageList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    deviceId: null,
    headType: null,
    usageCount: null,
    totalDuration: null,
    dailyDuration: null,
    weeklyDuration: null,
    monthlyDuration: null,
    lastUsedTime: null,
    updateTime: null
  }
  proxy.resetForm("usageRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加设备按头使用统计"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getUsage(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改设备按头使用统计"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["usageRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateUsage(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addUsage(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除设备按头使用统计编号为"' + _ids + '"的数据项？').then(function() {
    return delUsage(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => {})
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('device/usage/export', {
    ...queryParams.value
  }, `usage_${new Date().getTime()}.xlsx`)
}

getList()
</script>
